Modules/Admin/Routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::prefix('admin')->name('admin.')->middleware('auth', 'admin.auth')->group(function () {
    Route::get('/', function () {
        return view('admin::admin.index');
    })->name('admin.');

    Route::resource('users', 'user\UsersController');

    Route::get('/{user}/permission', 'PermissionController@create')->name('user.permission')->middleware('can:staff-user-permission');
    Route::post('/{user}/permission', 'PermissionController@store')->name('user.permission.store')->middleware('can:staff-user-permission');

    Route::resource('permission', 'PermissionController');

    Route::resource('role', 'RoleController');

    Route::resource('product', 'ProductController');

    Route::get('comments/unapproved', 'CommentsController@unapproved')->name('comments.unapproved');
    Route::resource('comments', 'CommentsController');

    Route::resource('category', 'CategoryController');

    Route::post('/attribute/values', 'AttributeController@getValues');

    Route::resource('orders', 'OrderController');
    Route::get('order/{order}/payment', 'OrderController@payment')->name('order.payment');

    Route::resource('product.gallery', 'ProductGalleryController');

    Route::resource('discount', 'DiscountController');


    Route::get('module', 'MainController@index')->name('module.index');
    Route::put('module/{module}/disable', 'MainController@disable')->name('module.disable');
    Route::put('module/{module}/enable', 'MainController@enable')->name('module.enable');


});

Modules/Admin/Http/Controllers/DiscountController.php
<?php

namespace Modules\Admin\Http\Controllers;

use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\Discount\Entities\Discount;

class DiscountController extends Controller
{
    /**
     * Display a listing of the resource.
     * @return Renderable
     */
    public function index()
    {
        $discounts = Discount::latest()->paginate(30);
        return view('admin::admin.discount.all', compact('discounts'));
    }

    /**
     * Show the form for creating a new resource.
     * @return Renderable
     */
    public function create()
    {
        return view('admin::admin.discount.create');
    }

    /**
     * Store a newly created resource in storage.
     * @param Request $request
     * @return Renderable
     */
    public function store(Request $request)
    {
        $data = $request->validate([
            'code' => 'required|unique:discounts,code',
            'percent' => 'required|integer|between:1,99',
            'expired_at' => 'required',
            'products' => 'exists:products,id|array|nullable',
            'categories' => 'exists:categories,id|array|nullable',
            'users' => 'exists:users,id|array|nullable'
        ]);


        $discount = Discount::create($data);
        if (isset($data['products'])) {
            $discount->products()->attach($data['products']);
        }
        if (isset($data['categorise'])) {
            $discount->categorise()->attach($data['categorise']);
        }
        if ($data['users']) {
            $discount->users()->attach($data['users']);
        }


        alert()->success('ذخیره شده');

        return redirect(route('admin.discount.index'));

    }

    /**
     * Show the form for editing the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function edit(Discount $discount)
    {
        return view('admin::admin.discount.edit', compact('discount'));
    }

    /**
     * Update the specified resource in storage.
     * @param Request $request
     * @param int $id
     * @return Renderable
     */
    public function update(Request $request, Discount $discount)
    {
        $data = $request->validate([
            'code' => ['required', Rule::unique('discounts', 'code')->ignore($discount->id)],
            'percent' => 'required|integer|between:1,99',
            'expired_at' => 'required',
            'products' => 'exists:products,id|array|nullable',
            'categories' => 'exists:categories,id|array|nullable',
            'users' => 'exists:users,id|array|nullable'
        ]);

        $discount->update($data);
        isset($data['products'])
            ? $discount->products()->sync($data['products'])
            : $discount->products()->detach();
        isset($data['categories'])
            ? $discount->categories()->attach($data['categories'])
            : $discount->categories()->detach();
        isset($data['users'])
            ? $discount->users()->attach($data['users'])
            : $discount->users()->detach();

        alert()->success('ذخیره شده');

        return redirect(route('admin.discount.index'));
    }

    /**
     * Remove the specified resource from storage.
     * @param int $id
     * @return Renderable
     */
    public function destroy(Discount $discount)
    {
        $discount->delete();
        alert()->success('حذف شده');
        return redirect(route('admin.discount.index'));
    }
}

Modules/Admin/Resources/views/admin/discount/all.blade.php
@component('admin::admin.layout.content' , ['title' => 'لیست تخفیف'])
    @slot('breadcrumb')
        <li class="breadcrumb-item"><a href="/admin">پنل مدیریت</a></li>
        <li class="breadcrumb-item active">لیست تخفیف‌ها</li>
    @endslot

    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">تخفیف‌ها</h3>

                    <div class="card-tools d-flex">
                        <form action="">
                            <div class="input-group input-group-sm" style="width: 150px;">
                                <input type="text" name="search" class="form-control float-right" placeholder="جستجو" value="{{ request('search') }}">

                                <div class="input-group-append">
                                    <button type="submit" class="btn btn-default"><i class="fa fa-search"></i></button>
                                </div>
                            </div>
                        </form>
                        <div class="btn-group-sm mr-1">
{{--                            @can('create-product')--}}
                                <a href="{{ route('admin.discount.create') }}" class="btn btn-info">ایجاد تخفیف جدید</a>
{{--                            @endcan--}}
                        </div>
                    </div>
                </div>
                <!-- /.card-header -->
                <div class="card-body table-responsive p-0">
                    <table class="table table-hover">
                        <tbody>
                        <tr>
                            <th>آی‌دی تخفیف</th>
                            <th>کد تخفیف</th>
                            <th>میزان تخفیف (درصد)</th>
                            <th>مربوط به کاربر</th>
                            <th>مربوط به محصول</th>
                            <th>مربوط به دسته</th>
                            <th>مهلت استفاده</th>
                            <th>اقدامات</th>
                        </tr>

                        @foreach($discounts as $discount)
                            <tr>
                                <td>{{ $discount->id }}</td>
                                <td>{{ $discount->code }}</td>
                                <td>{{ $discount->percent }}</td>
                                <td>{{ $discount->users->count() ? $discount->users->pluck('name')->join(', ') : 'همه کاربران' }}</td>
                                <td>{{ $discount->products->count() ? $discount->products->pluck('title')->join(', ') : 'همه محصولات' }}</td>
                                <td>{{ $discount->categories->count() ?  $discount->categories->pluck('name')->join(', ') : 'همه دسته‌ها' }}</td>
                                <td>{{ jdate($discount->expired_at)->ago() }}</td>
                                <td class="d-flex">
{{--                                    // permissions--}}
                                    <form action="{{ route('admin.discount.destroy' , $discount->id) }}" method="POST">
                                        @csrf
                                        @method('DELETE')
                                        <button type="submit" class="btn btn-sm btn-danger ml-1">حذف</button>
                                    </form>
                                    <a href="{{ route('admin.discount.edit' , $discount->id) }}" class="btn btn-sm btn-primary ml-1">ویرایش</a>
                                </td>
                            </tr>
                        @endforeach


                        </tbody>
                    </table>
                </div>
                <!-- /.card-body -->
                <div class="card-footer">
                    {{ $discounts->appends([ 'search' => request('search') ])->render() }}
                </div>
            </div>
            <!-- /.card -->
        </div>
    </div>

@endcomponent

Modules/Admin/Resources/views/admin/discount/create.blade.php
@component('admin::admin.layout.content' , ['title' => 'ایجاد کد تخفیف'])
    @slot('breadcrumb')
        <li class="breadcrumb-item"><a href="/admin">پنل مدیریت</a></li>
        <li class="breadcrumb-item"><a href="{{ route('admin.discount.index') }}">لیست تخفیف‌ها</a></li>
        <li class="breadcrumb-item active">ایجاد کد تخفیف</li>
    @endslot

    @slot('script')
        <script>

            $('#users').select2({
                'placeholder': 'محصول مورد نظر را انتخاب کنید'
            })

            $('#products').select2({
                'placeholder': 'محصول مورد نظر را انتخاب کنید'
            })

            $('#categories').select2({
                'placeholder': 'دسته مورد نظر را انتخاب کنید'
            })
        </script>
    @endslot

    <div class="row">
        <div class="col-lg-12">
            {{--            @include('admin.layouts.errors')--}}
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">فرم ایجاد کد تخفیف</h3>
                </div>
                <!-- /.card-header -->
                @if($errors->any())
                    <div class="alert alert-danger">
                        <ul>
                            @foreach($errors->all() as $err)
                                <li>
                                    {{ $err }}
                                </li>
                            @endforeach
                        </ul>
                    </div>
            @endif
            <!-- form start -->
                <form class="form-horizontal" action="{{ route('admin.discount.store') }}" method="POST">
                    @csrf

                    <div class="card-body">
                        <div class="form-group">
                            <label for="inputEmail3" class="col-sm-2 control-label">کد تخفیف</label>
                            <input type="text" name="code" class="form-control" id="inputEmail3"
                                   placeholder="کد تخفیف را وارد کنید" value="{{ old('code') }}">
                        </div>
                        <div class="form-group">
                            <label for="precent" class="col-sm-2 control-label">میزان تخفیف (درصد)</label>
                            <input type="number" name="percent" class="form-control"
                                   placeholder="درصد تخفیف را وارد کنید" value="{{ old('percent') }}">
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">کاربر مربوط به تخفیف (اختیاری)</label>
                            <select class="form-control" name="users[]" id="users" multiple>
                                <option value="null">همه کاربرها</option>
                                @foreach(\App\Models\User::all() as $user)
                                    <option value="{{ $user->id }}">{{ $user->name }}</option>
                                @endforeach
                            </select>
                        </div>
                        <div class="form-group">
                            <label for="inputPassword3" class="col-sm-2 control-label">محصول مربوطه (اختیاری)</label>
                            <select class="form-control" name="products[]" id="products" multiple>
                                <option value="null">همه محصول</option>
                                @foreach(\Modules\Product\Entities\Product::all() as $product)
                                    <option value="{{ $product->id }}">{{ $product->title }}</option>
                                @endforeach
                            </select>
                        </div>
                        <div class="form-group">
                            <label for="inputPassword3" class="col-sm-2 control-label">دسته‌بندی مربوطه
                                (اختیاری)</label>
                            <select class="form-control" name="categories[]" id="categories" multiple>
                                <option value="null">همه دسته‌ها</option>
                                @foreach(\Modules\Category\Entities\Category::all() as $category)
                                    <option value="{{ $category->id }}">{{ $category->name }}</option>
                                @endforeach
                            </select>
                        </div>
                        <div class="form-group">
                            <label for="inputEmail3" class="col-sm-2 control-label">مهلت استفاده</label>
                            <input type="datetime-local" name="expired_at" class="form-control" id="inputEmail3"
                                   placeholder="ملهت استفاده را وارد کنید" value="{{ old('expired_at') }}">
                        </div>
                    </div>
                    <!-- /.card-body -->
                    <div class="card-footer">
                        <button type="submit" class="btn btn-info">ثبت کد تخفیف</button>
                        <a href="{{ route('admin.discount.index') }}" class="btn btn-default float-left">لغو</a>
                    </div>
                    <!-- /.card-footer -->
                </form>
            </div>
        </div>
    </div>



@endcomponent

Modules/Admin/Resources/views/admin/discount/edit.blade.php
@component('admin::admin.layout.content' , ['title' => 'ویرایش کد تخفیف'])
    @slot('breadcrumb')
        <li class="breadcrumb-item"><a href="/admin">پنل مدیریت</a></li>
        <li class="breadcrumb-item"><a href="{{ route('admin.discount.index') }}">لیست تخفیف‌ها</a></li>
        <li class="breadcrumb-item active">ویرایش کد تخفیف</li>
    @endslot

    @slot('script')

        <script>
            $('#products').select2({
                'placeholder' : 'محصول مورد نظر را انتخاب کنید'
            })

            $('#categories').select2({
                'placeholder' : 'دسته مورد نظر را انتخاب کنید'
            })
        </script>
    @endslot

    <div class="row">
        <div class="col-lg-12">
{{--            @include('admin.layouts.errors')--}}
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">فرم ویرایش کد تخفیف</h3>
                </div>
                <!-- /.card-header -->
                @if($errors->any())
                    <div class="alert alert-danger">
                        <ul>
                            @foreach($errors->all() as $err)
                                <li>
                                    {{ $err }}
                                </li>
                            @endforeach
                        </ul>
                    </div>
            @endif
                <!-- form start -->
                <form class="form-horizontal" action="{{ route('admin.discount.update' , $discount->id) }}" method="POST">
                    @csrf
                    @method('PATCH')

                    <div class="card-body">
                        <div class="form-group">
                            <label for="inputEmail3" class="col-sm-2 control-label">کد تخفیف</label>
                            <input type="text" name="code" class="form-control" id="inputEmail3" placeholder="کد تخفیف را وارد کنید" value="{{ old('code', $discount->code) }}">
                        </div>
                        <div class="form-group">
                            <label for="precent" class="col-sm-2 control-label">میزان تخفیف (درصد)</label>
                            <input type="number" name="percent" class="form-control" placeholder="درصد تخفیف را وارد کنید" value="{{ old('percent',$discount->percent) }}">
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">ایمیل کاربر استفاده کننده (اختیاری)</label>
                            <input type="email" name="user" class="form-control" placeholder="ایمیل کاربر را وارد کنید" value="{{ old('user',$discount->email) }}">
                        </div>
                        <div class="form-group">
                            <label for="inputPassword3" class="col-sm-2 control-label">محصول مربوطه (اختیاری)</label>
                            <select class="form-control" name="products[]" id="products" multiple>
                                <option value="null">همه دسته‌ها</option>
                                @foreach(\App\Product::all() as $product)
                                    <option value="{{ $product->id }}" {{ $discount->products && in_array($product->id , $discount->products->pluck('id')->toArray()) ? 'selected' : '' }}>{{ \App\Product::find($product->id)->title }}</option>
                                @endforeach
                            </select>
                        </div>
                        <div class="form-group">
                            <label for="inputPassword3" class="col-sm-2 control-label">دسته‌بندی مربوطه (اختیاری)</label>
                            <select class="form-control" name="categories[]" id="categories" multiple>
                                <option value="null">همه دسته‌ها</option>
                                @foreach(\App\Category::all() as $category)
                                    <option value="{{ $category->id }}" {{ in_array($category->id , $discount->categories->pluck('id')->toArray()) ? 'selected' : '' }}>{{ $category->name }}</option>
                                @endforeach
                            </select>
                        </div>
                        <div class="form-group">
                            <label for="inputEmail3" class="col-sm-2 control-label">مهلت استفاده</label>
                            <input type="datetime-local" name="expired_at" class="form-control" id="inputEmail3"
                                   placeholder="ملهت استفاده را وارد کنید" value="{{ old('expired_at',\Carbon\Carbon::parse($discount->expired_at)->format('Y-m-d\TH:i:s')) }}">
                        </div>
                    </div>
                    <!-- /.card-body -->
                    <div class="card-footer">
                        <button type="submit" class="btn btn-info">ویرایش کد تخفیف</button>
                        <a href="{{ route('admin.discount.index') }}" class="btn btn-default float-left">لغو</a>
                    </div>
                    <!-- /.card-footer -->
                </form>
            </div>
        </div>
    </div>



@endcomponent